#!/usr/bin/perl -w
#+
# Name:
#
#
# Funktion:
#
#
# Parameter:
#
#
# Autor:
#   HdR
#
# nderungen:
#   2003-12-21:  Erste Version
#-

use strict;

sub TITLE ($) # Holt den DVD-Titel, Anzahl der Titel, Anzahl der Sektoren der einzeilnen Titel
{ my $para = shift;

  print "Lese Titel ...";
  my ($tmp, $last_title, @azeile);

  my @zeilen;

  open (PROBE, $para->{'TCPROBE'} . " -T 1 -i " . $para->{'DVD_PATH'} . " -d verbosity 2>&1 |");
  @zeilen = <PROBE>;
  close(PROBE);

  foreach my $p(@zeilen)
  { @azeile = (split /\ /, $p);
    if ($azeile[1] eq "DVD" && $azeile[2] eq "title")
    { $azeile[3] =~ s/://;
      ($tmp, $last_title) = (split /\//, $azeile[3]);
    }
  }

  ######### Sectors ###############

  open (LSDVD, $para->{'LSDVD'} . " " . $para->{'DVD_PATH'} . " -c 2>&1 |");
  @zeilen = <LSDVD>;
  close (LSDVD);

  my $schleife = 0;
  my $lang = @zeilen+0;

  my $nr = 1;

  my ($dvd_title, @sectors);

  while ($schleife < $lang)
  { @azeile = (split /\ /, $zeilen[$schleife]);
    if ($azeile[0] eq "Disc" && $azeile[1] eq "Title:")
    { $dvd_title = $azeile[2];
    }
    elsif ($azeile[0] eq "Total" && $azeile[1] eq "Sectors:")
    { $sectors[$nr] = $azeile[2];
      ++$nr;
    }
    ++$schleife;
  }

  my $return2 = \@sectors;
  my $return3 = $dvd_title;

  #################################

  print " Fertig\n";
  return($last_title, $return2, $return3);
}

sub CHAPTER ($) # Holt die Kapitelstartzeiten, Spracheninfos ...
{ my $parameter = shift;

  sub PROG ($$);

  print "Hole Kapitelzeiten ...";
  my (@chapters, @zeilen, @azeile, @sprachen, @sprachen_mode, @audiosize, @untertitel, $schleife2, $lang,
      $return, $return2, $return3, $return4, $return5, $return6);
  my $schleife = 1;

  my @title_length;

  if ($parameter->{'LAST_TITLE'} > 1)
  { while ($schleife <= $parameter->{'LAST_TITLE'})
    { ($chapters[$schleife], $title_length[$schleife], $sprachen[$schleife], $sprachen_mode[$schleife], $audiosize[$schleife], $untertitel[$schleife]) =
       PROG ($parameter, $schleife);
      ++$schleife;
    }
  }
  elsif ($parameter->{'LAST_TITLE'} == 1)
  { ($chapters[1], $title_length[1], $sprachen[1], $sprachen_mode[1], $audiosize[1]) = PROG ($parameter, 1);
  }

  $return = \@chapters;
  $return2 = \@title_length;
  $return3 = \@sprachen;
  $return4 = \@sprachen_mode;
  $return5 = \@audiosize;
  $return6 = \@untertitel;
  print " Fertig\n";
  return($return, $return2, $return3, $return4, $return5, $return6);

  sub PROG ($$)
  { my $para = shift; 
    my $titel_nr = shift;
    my $title_length;

    open (PROBE, $para->{'TCPROBE'} . " -T $titel_nr -i " . $para->{'DVD_PATH'} . " -d verbosity 2>&1 |");
    my @zeilen = <PROBE>;
    close (PROBE);

    my $schleife2 = 0;
    my $lang = (@zeilen+0) - 1;

    my (@achapter, @sprachen, @sprachen_mode, @sub_titles);
    my $nspr = 0;

    my $audio_size = 0;

    while ($schleife2 <= $lang)
    { chop $zeilen[$schleife2];
      $zeilen[$schleife2] =~ s/\[//g;
      $zeilen[$schleife2] =~ s/\]//g;
      my @azeile = (split /\ /, $zeilen[$schleife2]);

      if ($azeile[1] eq "Chapter")
      { $achapter[$azeile[2]] = $azeile[3];
      }

      if ($azeile[1] eq "title" && $azeile[2] eq "playback" && $azeile[3] eq "time:")
      { $title_length = $azeile[6];
      }

      if ($azeile[1] eq "subtitle")
      { my ($nr, $uuu) = (split /=/, $azeile[2]);
        $uuu =~ s/<//;
        $uuu =~ s/>//;
        $sub_titles[$nr] = $uuu;
      }

      if ($azeile[1] eq "ac3")
      { $sprachen[$nspr] = $azeile[2];
        $sprachen_mode[$nspr] = $azeile[8];
        
        if ((@azeile+0) >= 9)
        { if ($azeile[8] eq "1Ch" || $azeile[8] eq "2Ch")
          { $audio_size += $title_length * 128 * 125;
          }
          else
          { $audio_size += $title_length * 384 * 125;
          }
        }
        ++$nspr;
      }
      elsif ($azeile[1] eq "dts")
      { $audio_size += $title_length * 786 * 125;
      }

      ++$schleife2;
    }

    my $rueck1 = \@achapter;
    my $rueck2 = $title_length;
    my $rueck3 = \@sprachen;
    my $rueck4 = \@sprachen_mode;
    my $rueck5 = $audio_size;
    my $rueck6 = \@sub_titles;
    return ($rueck1, $rueck2, $rueck3, $rueck4, $rueck5, $rueck6);
  }
}

sub INFO_REQUANT ($) # Brechnet den Verkleinerungsfaktor
{ my $para = shift;
  print "Berechne Verkleinerungsfaktor ...";
  my $faktor;
  my ($video_size, $audio_size);

  if ($para->{'MODUS'} eq '1' || $para->{'MODUS'} eq '2')
  { my $video_file = $para->{'PATH'} . "/stream/movie.m2v";
    $video_size = (stat $video_file)[7];
    my $audio_file = $para->{'PATH'} . "/stream/movie-p.ac3";
    $audio_size = (stat $audio_file)[7];
    if (defined $para->{'AUDIO2_RIP'})
    { my $audio_file2 = $para->{'PATH'} . "/stream/movie-s.ac3";
      $audio_size += (stat $audio_file2)[7];
    }
  }
  elsif ($para->{'MODUS'} eq 'STREAM_DVD' || $para->{'MODUS'} eq 'TR_PAR')
  { my @sprachen_mode = @{@{$para->{'SPRACHEN_MODE'}}[$para->{'TITLE_RIP'}]};
    my @title_length = @{$para->{'TITLE_LENGTH'}};
    if ($sprachen_mode[$para->{'AUDIO1_RIP'}] eq "6Ch" || $sprachen_mode[$para->{'AUDIO2_RIP'}] eq "7Ch")
    { $audio_size = ($title_length[$para->{'TITLE_RIP'}] * 384 * 125);
      if (defined $para->{'AUDIO2_RIP'})
      { $audio_size += $audio_size;
      }
    }
    else
    { $audio_size = ($title_length[$para->{'TITLE_RIP'}] * 128 * 125);
      if (defined $para->{'AUDIO2_RIP'})
      { $audio_size += $audio_size;
      }
    }

    my @sectors = @{$para->{'SECTORS'}};
    my @audio_sizes = @{$para->{'AUDIO_SIZE'}};
    $video_size = ($sectors[$para->{'TITLE_RIP'}] * 2048) - $audio_sizes[$para->{'TITLE_RIP'}];
  }

  if (($video_size + $audio_size) <= $para->{'DVD_SIZE'})
  { $faktor = 1;
  }
  else
  { $faktor = $video_size / ($para->{'DVD_SIZE'} - $audio_size);
  }

  print " Fertig ($faktor)\n";
  return($faktor);
}

1;
